#include "mascota.h"
#include <assert.h>
#include <stdlib.h>

/* MASCOTA VIRTUAL : TAMAGOTCHI */

struct _mascota {
    int hambre;
    int diversion;
    bool viva;
};

mascota_t mascota_crear() {
    struct _mascota m;
    m.hambre = 0;
    m.diversion = 0;
    m.viva = true;

    /* El siguiente puntero apunta a una
       una estructura alojada en una variable local,
       que será eliminada por el sistema cuando
       mascota_crear finalice. 
    */
    struct _mascota *pm = &m;

    /* !!! Mal: Devuelvo una referencia a una variable local !!! */
    return (pm);
}

mascota_t mascota_jugar(mascota_t mascota) {
    assert(mascota->viva);
    mascota->hambre++;
    mascota->diversion++;
    if (mascota->hambre > 3) {
	mascota->viva = false;
    }
    return (mascota);
}

mascota_t mascota_comer(mascota_t mascota) {
    assert(mascota->viva);
    mascota->hambre = 0;
    return (mascota);
}

bool mascota_esta_viva(mascota_t mascota) {
    return (mascota->viva);
}

int mascota_nivel_hambre(mascota_t mascota) {
    return (mascota->hambre);
}

mascota_t mascota_destruir(mascota_t mascota) {
    free(mascota);
    mascota = NULL;
    return (mascota);
}
