#include "mascota.h"
#include <assert.h>
#include <stdlib.h>

/* MASCOTA VIRTUAL : TAMAGOTCHI */

struct _mascota {
    int hambre;
    int diversion;
    bool viva;
};

mascota_t mascota_crear() {
    mascota_t pm = calloc(1, sizeof(struct _mascota));
    assert(pm != NULL);
    pm->hambre = 0;
    pm->diversion = 0;
    pm->viva = true;
    return (pm);
}

mascota_t mascota_jugar(mascota_t mascota) {
    assert(mascota->viva);
    mascota->hambre++;
    mascota->diversion++;
    if (mascota->hambre > 3) {
	mascota->viva = false;
    }
    return (mascota);
}

mascota_t mascota_comer(mascota_t mascota) {
    assert(mascota->viva);
    mascota->hambre = 0;
    return (mascota);
}

bool mascota_esta_viva(mascota_t mascota) {
    return (mascota->viva);
}

int mascota_nivel_hambre(mascota_t mascota) {
    return (mascota->hambre);
}

mascota_t mascota_destruir(mascota_t mascota) {
    free(mascota);
    mascota = NULL;
    return (mascota);
}
